--[[----------------------------------------------------------------------------

WFInsomniaTest.lua

--------------------------------------------------------------------------------

ADOBE CONFIDENTIAL
------------------
Copyright 2017 Adobe Systems Incorporated
All Rights Reserved.

NOTICE: All information contained herein is, and remain the property of
Adobe Systems Incorporated and its suppliers, if any. The intellectual and
technical concepts contained herein are proprietary to Adobe Systems
Incorporated and its suppliers and may be covered by U.S. and Foreign
Patents, patents in process, and are protected by trade secret or copyright
law.  Dissemination of this information or reproduction of this material is
strictly forbidden unless prior written permission is obtained from
Adobe Systems Incorporated.

------------------------------------------------------------------------------]]

	-- WF.core.os
local WFInsomnia = require 'WFInsomnia'
local WFPlatformInfo = require 'WFPlatformInfo'

	-- WF.core.self_test
local WFRxTestCase = require 'WFRxTestCase'

--============================================================================--

local WFInsomniaTest = {}

--------------------------------------------------------------------------------

function WFInsomniaTest.rxTestBasic( rxTest )

	rxTest:setTimeLimit( 10 )

	local sleepDuration = 0.2

	WFInsomnia.preventSystemSleep( "testingSleep", false, sleepDuration )
	
	local isPreventingSleep, isPreventingDisplaySleep = WFInsomnia.isPreventingSleep()
	
	rxTest:expectEqual( true, isPreventingSleep )
	rxTest:expectEqual( false, isPreventingDisplaySleep )
	
	rxTest:sleep( .5 )
	
	isPreventingSleep, isPreventingDisplaySleep = WFInsomnia.isPreventingSleep()
	
	rxTest:expectEqual( false, isPreventingSleep )
	rxTest:expectEqual( false, isPreventingDisplaySleep )
	
	WFInsomnia.preventSystemSleep( "testingisplaySleep", true, sleepDuration )
	
	isPreventingSleep, isPreventingDisplaySleep = WFInsomnia.isPreventingSleep()
	
	rxTest:expectEqual( true, isPreventingSleep )
	rxTest:expectEqual( true, isPreventingDisplaySleep )
	
	rxTest:sleep( 0.5 )
	
	isPreventingSleep, isPreventingDisplaySleep = WFInsomnia.isPreventingSleep()
	
	rxTest:expectEqual( false, isPreventingSleep )
	rxTest:expectEqual( false, isPreventingDisplaySleep )
	
end

--------------------------------------------------------------------------------

if WFPlatformInfo.isMac or WFPlatformInfo.isWindows then
	return WFRxTestCase.wrapSuite( WFInsomniaTest )
else
	return {}
end
